import type * as ts from 'typescript/lib/tsserverlibrary';
import type { VueCompilerOptions, TextRange } from '../types';
export interface ScriptSetupRanges extends ReturnType<typeof parseScriptSetupRanges> {
}
export declare function parseScriptSetupRanges(ts: typeof import('typescript/lib/tsserverlibrary'), ast: ts.SourceFile, vueCompilerOptions: VueCompilerOptions): {
    leadingCommentEndOffset: number;
    importSectionEndOffset: number;
    bindings: TextRange[];
    withDefaultsArg: TextRange | undefined;
    withDefaults: TextRange | undefined;
    defineProps: TextRange | undefined;
    defineSlots: TextRange | undefined;
    defineEmits: TextRange | undefined;
    defineExpose: TextRange | undefined;
    propsAssignName: string | undefined;
    propsRuntimeArg: TextRange | undefined;
    propsTypeArg: TextRange | undefined;
    slotsAssignName: string | undefined;
    emitsAssignName: string | undefined;
    exposeRuntimeArg: TextRange | undefined;
    exposeTypeArg: TextRange | undefined;
    defineProp: {
        name: TextRange | undefined;
        nameIsString: boolean;
        type: TextRange | undefined;
        defaultValue: TextRange | undefined;
        required: boolean;
    }[];
};
export declare function parseBindingRanges(ts: typeof import('typescript/lib/tsserverlibrary'), sourceFile: ts.SourceFile, isType: boolean): TextRange[];
export declare function findBindingVars(ts: typeof import('typescript/lib/tsserverlibrary'), left: ts.BindingName, sourceFile: ts.SourceFile): TextRange[];
export declare function getStartEnd(node: ts.Node, sourceFile: ts.SourceFile): {
    start: number;
    end: number;
};
//# sourceMappingURL=scriptSetupRanges.d.ts.map